This repository contains original code and model parameters to used in the analyses and simulations described in our work investigating and modeling the 3D structure of the human SOX9 domain in embryonic stem cells and cranial neural crest cells:

 "Structural elements facilitate extreme long-range gene regulation at a human disease locus".

Liang-Fu Chen<sup>a,\*</sup>, Hannah Katherine Longa<sup>\*,†</sup>, Minhee Park<sup>b,‡</sup>, Tomek Swigut<sup>a</sup>, Alistair Boettiger<sup>b</sup>, Joanna Wysocka<sup>a, b, c, d</sup>


<sup>a</sup> Department of Chemical and Systems Biology, Stanford University School of Medicine, Stanford, CA 94305, USA

<sup>b</sup> Department of Developmental Biology, Stanford University School of Medicine, Stanford, CA 94305, USA

<sup>c</sup> Institute of Stem Cell Biology and Regenerative Medicine, Stanford University School of Medicine, Stanford, CA 94305, USA

<sup>d</sup> Howard Hughes Medical Institute, Stanford University School of Medicine, Stanford, CA 94305, USA
<sup>\*</sup> Joint first authors

<sup>†</sup> Current address: MRC Human Genetics Unit, Institute of Genetics and Cancer, University of Edinburgh, Crewe Road, Edinburgh, UK

<sup>‡</sup> Current address: Department of Biological Sciences, Korea Advanced Institute of Science and Technology (KAIST), Daejeon, Republic of Korea

Correspondence: boettiger@stanford.edu , wysocka@stanford.edu

The intention of this repository is to make the transparent the workflow behind the data analysis and behind the simulations.  

The chromatin tracing image data is deposited at the [4DN data portal](https://data.4dnucleome.org/) and can be retrieved there, following publication and public release.  We will update the link here when it is available.  

To run the polymer simulations, this code requires the open-access [polychrom repository](https://github.com/open2c/polychrom) developed by the open2c team.  We added several additional functions to the repository to allow non-uniform loading of Cohesin.  These additions can be found in our open-access fork of the project, [https://github.com/BoettigerLab/polychrom](https://github.com/BoettigerLab/polychrom).  
 